function getContentBrowser(){
	var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	                     .getService(Components.interfaces.nsIWindowMediator);
	var topWindowOfType = windowMediator.getMostRecentWindow("navigator:browser");
	if(topWindowOfType) return topWindowOfType.document.getElementById("content");
	return null;
}

function getPrefBranch(){
	if(!removetabs_pref_branch_cache){
		removetabs_pref_branch_cache = Components.classes["@mozilla.org/preferences-service;1"]
		                           .getService(Components.interfaces.nsIPrefBranch);
	}
	return removetabs_pref_branch_cache;
}
var removetabs_pref_branch_cache = null;

function removetabs_removeleft(usecontext) {
	var contentBrowser = getContentBrowser();
	var tabs = contentBrowser.tabContainer;
	var ctab = (usecontext ? contentBrowser.mContextTab : contentBrowser.selectedTab);
	var i;
	for(i=tabs.childNodes.length-1; tabs.childNodes[i] != ctab; i--){}
	for(i--; i>=0; i--){
		contentBrowser.removeTab(tabs.childNodes[i]);
	}
	removetabs_updateEnabled();
}

function removetabs_removeright(usecontext) {
	var contentBrowser = getContentBrowser();
	var tabs = contentBrowser.tabContainer;
	var ctab = (usecontext ? contentBrowser.mContextTab : contentBrowser.selectedTab);
	for(var i=tabs.childNodes.length-1; tabs.childNodes[i] != ctab; i--){
		contentBrowser.removeTab(tabs.childNodes[i]);
	}
	removetabs_updateEnabled();
}

function removetabs_removeother(usecontext) {
	var contentBrowser = getContentBrowser();
	var ctab = (usecontext ? contentBrowser.mContextTab : contentBrowser.selectedTab);
	contentBrowser.removeAllTabsBut(ctab);
	removetabs_updateEnabled();
}

function removetabs_removeall(usecontext) {
	var contentBrowser = getContentBrowser();
	var ctab = contentBrowser.addTab("about:blank");
	contentBrowser.removeAllTabsBut(ctab);
	if(contentBrowser.tabContainer.childNodes.length > 1) {
		contentBrowser.removeTab(ctab);
	}
	removetabs_updateEnabled();
}

function removetabs_setDisabled(id, value) {
	var item = document.getElementById(id);
	if(item == null){ return; }
	item.setAttribute("disabled", value);
}

function removetabs_updateEnabled() {
	var contentBrowser = getContentBrowser();
	var tabs = contentBrowser.tabContainer;
	removetabs_setDisabled("tab-removeleftmenu",
		(tabs.childNodes[0] == contentBrowser.mContextTab));
	removetabs_setDisabled("tab-removerightmenu",
		(tabs.childNodes[tabs.childNodes.length-1] == contentBrowser.mContextTab));
	removetabs_setDisabled("tab-removeallmenu",
		(tabs.childNodes.length <= 1 && 
		 contentBrowser.currentURI.spec == "about:blank"));
	removetabs_setDisabled("removeleftbutton",
		(tabs.childNodes[0] == contentBrowser.selectedTab));
	removetabs_setDisabled("removerightbutton",
		(tabs.childNodes[tabs.childNodes.length-1] == contentBrowser.selectedTab));
	removetabs_setDisabled("removeotherbutton",
		(tabs.childNodes.length <= 1));
	removetabs_setDisabled("removeallbutton",
		(tabs.childNodes.length <= 1 && 
		 contentBrowser.currentURI.spec == "about:blank"));
}

function removetabs_addMenuItem(contentBrowser, menuid) {
	var removetabsMenu = document.getElementById(menuid).cloneNode(false);
	if(!removetabsMenu){ return; }
	removetabsMenu.id = "tab-" + menuid;
	var menuParent = contentBrowser.mStrip.firstChild.nextSibling;
	var pos = 4;
	if(pos >= menuParent.childNodes.length){
	  menuParent.appendChild(removetabsMenu);
	}else{
	  menuParent.insertBefore(removetabsMenu, menuParent.childNodes[pos]);
	}
}

function removetabs_addMenuItems() {
	var contentBrowser = getContentBrowser();
	if(!contentBrowser){ return; }
	if(removetabs_getPrefValue("skz.removetabs.add_removeleft_menu")) {
		removetabs_addMenuItem(contentBrowser, "removeleftmenu");
	}
	if(removetabs_getPrefValue("skz.removetabs.add_removeright_menu")) {
		removetabs_addMenuItem(contentBrowser, "removerightmenu");
	}
	if(removetabs_getPrefValue("skz.removetabs.add_removeall_menu")) {
		removetabs_addMenuItem(contentBrowser, "removeallmenu");
	}
	contentBrowser.tabContainer.addEventListener("click", removetabs_updateEnabled, false);
	var contentArea = document.getElementById("appcontent");
	contentArea.addEventListener("load", removetabs_updateEnabled, true);
	contentArea.addEventListener("select", removetabs_updateEnabled, false);
	contentArea.addEventListener("unload", removetabs_updateEnabled, true);
	removetabs_updateEnabled();
}



function removetabs_getPrefValue(aPrefString){
	var defaultValue = removetabs_getDefaultValue(aPrefString);
	var result = defaultValue;

	try{
		switch(typeof(defaultValue)){
			case "boolean":
				result = getPrefBranch().getBoolPref(aPrefString);
				break;
			case "number":
				result = getPrefBranch().getIntPref(aPrefString);
				break;
			case "string":
				result = getPrefBranch().getComplexValue(aPrefString,
					Components.interfaces.nsISupportsString).data;
				break;
		}
	}catch(ex){
		result = defaultValue;
	}		
	return result;
}

function removetabs_getDefaultValue(aPrefString){
	switch(aPrefString){
		case "skz.removetabs.add_removeleft_menu":
			return true;
		case "skz.removetabs.add_removeright_menu":
			return true;
		case "skz.removetabs.add_removeall_menu":
			return false;
	}
	return 0;
}

