
function removetabs_setting_startup(){
	removetabs_setting_load();
}

function removetabs_setting_accept(){
	removetabs_setting_save();
	return true;
}

function removetabs_setting_load(){
	var prefElements = document.getElementsByAttribute("prefelement", "true");
	
	for(var i=0; i<prefElements.length; i++){
		var prefElement = prefElements[i];
		var prefString = prefElement.getAttribute("prefstring");
		var prefAttribute = prefElement.getAttribute("prefattribute");

		var prefValue = removetabs_getPrefValue(prefString);

		prefElement[prefAttribute] = prefValue;
		prefElement.setAttribute(prefAttribute, prefValue);
	}
}

function removetabs_setting_save(){
	var prefElements = document.getElementsByAttribute("prefelement", "true");
	
	for(var i=0; i<prefElements.length; i++){
		var prefElement = prefElements[i];
		var prefString = prefElement.getAttribute("prefstring");
		var prefAttribute = prefElement.getAttribute("prefattribute");

		var prefValue = prefElement[prefAttribute];
		var prefLastValue = removetabs_getPrefValue(prefString);
		var prefType = typeof(removetabs_getDefaultValue(prefString));

		if(prefType == "number"){
			prefValue = parseInt(prefValue);
			if(isNaN(prefValue)) { prefValue = prefLastValue; }
		}

		if(prefValue != prefLastValue) {
			removetabs_setting_setPrefValue(prefString, prefValue);
		}
	}
}

function removetabs_setting_setPrefValue(aPrefString, aPrefValue) {
	var defaultValue = removetabs_getDefaultValue(aPrefString);
  var prefBranch = getPrefBranch();

	switch(typeof(defaultValue)){
		case "boolean":
			prefBranch.setBoolPref(aPrefString, aPrefValue);
			break;
		case "number":
			prefBranch.setIntPref(aPrefString, aPrefValue);
			break;
		case "string":
			var supportsString = Components.classes["@mozilla.org/supports-string;1"]
				.createInstance(Components.interfaces.nsISupportsString);
			supportsString.data = aPrefValue;
			prefBranch.setComplexValue(aPrefString,
				Components.interfaces.nsISupportsString, supportsString);
			break;
	}
}
